Subject: Re: [PATCH v2 net-next] bpf: fix bpf_perf_event_read() helper

From: Alexei Starovoitov <[email-masked]>
Date: Wed, 21 Oct 2015 22:00:12 -0700

On 10/21/15 9:49 PM, Wangnan (F) wrote:
> After applying this patch I'm unable to use perf passing perf_event
> again like this:

please do not top post and trim your replies.

>   # perf record -a -e evt=cycles -e
> ./test_config_map.c/maps.pmu_map.event=evt/ --exclude-perf ls
>
> With -v it output:
>
> ...
> adding perf_bpf_probe:func_write
> adding perf_bpf_probe:func_write to 0x367d6a0
> add bpf event perf_bpf_probe:func_write_return and attach bpf program 6
> adding perf_bpf_probe:func_write_return
> adding perf_bpf_probe:func_write_return to 0x3a7fc40
> mmap size 528384B
> ERROR: failed to insert value to pmu_map[0]
> ERROR: Apply config to BPF failed: Invalid option for map, add -v to see
> detail
> Opening /sys/kernel/debug/tracing//kprobe_events write=
> ...
>
> Looks like perf sets attr.inherit for cycles? I'll look into this problem.

yes. that's perf default.
How did it even work before?!
I was testing with your samples/bpf/tracex6 that sets inherit to zero.